<?php

/*-------------------------------------------------------------- 
Artikel: Sicherheitsfeld mit PHP, GDlib und Freetype ----
Internet: www.contentcharge.de , Mail: info@contentcharge.de
Disclaimer: Fuer den Einsatz dieses Scriptes und
evtl. daraus resultierenden Folgen uebernehmen wir 
keine Haftung.

Article: Securityfield (captcha) with PHP, GDlib and Freetype
Contact: www.contentcharge.de, Mail: info@contentcharge.de
Disclaimer: We are not responsible for the use of this ressource
in part or whole. So use at your own risk.

Copyright 2007 Contentcharge-Media, Christian Lehmann
---------------------------------------------------------------*/


/*--------------------------------------------------------------
Diese Scriptversion verwendet Sessions um die Vergleichswerte
bereit zu stellen.

This version of the script is using sessions to provide the 
fieldvalue
---------------------------------------------------------------*/


//DE:  Das Starten der Session
//ENG: Start the session
session_start();

//DE : Basisvariablen setzen damit ein spammer nicht tricksen kann
//ENG: Set the basic vars so that there won't be any spammer tricks
if(!isset($_SESSION['iperror'])) $_SESSION['iperror'] = 0;
if(!isset($_SESSION['captcha'])) $_SESSION['captcha'] = rand(100000,999999);

//DE:  Wenn das Script die Eingabe Checken soll
//ENG: The script needs to check the input of the formfield
if($_GET['doit'] == "check"){

	//DE:  Teste ob alle notwendinge Felder vorhanden sind, Eingabevergleich, behandle Fehlversuche    
	//ENG: Ceck if all needed fields are provided, validate userinput, handle wrong tries
	if( $_POST['sec_eingabe'] == $_SESSION['captcha'] && $_SESSION['iperror']<5 && isset($_POST['sec_eingabe']) ){

        //DE:  Datum der Sendung
        //ENG: Current date 
		$datum = date("d.m.Y - H:i");

        //DE:  Hier bitte die Empfaenger-Mailadresse einfuegen
        //ENG: Change the E-Mail to your adress -- We get a bunch of Testmails currently ;)
		$empfaenger = "lehmann@contentcharge.de"; //********** ERSETZEN DURCH EIGENE DATEN ********** REPLACE WITH YOUR DATA *************

        //DE:  Zeilenende ersetzen
        //ENG: Replace end of line
		$suchen = "\r";      
		$ersetzen = "\n";
		$kommentarp = str_replace($suchen,$ersetzen,$_POST["memo"]);

		//DE:  Entferne tags (z.B. aus scripten)
		//ENG: Remove tags (ex. from scripts)
		$kommentarp = strip_tags($kommentarp);
		$betreff = strip_tags($_POST['betreff']);
		
		//DE:  Wenn Nachricht vorhanden, Mail senden
		//ENG: If there is a message, send Mail
		if($kommentarp != ''){
			mail("$empfaenger", "$betreff", "$kommentarp
				Name: ".strip_tags($_POST["name"])."
				Sek-Input: ".strip_tags($_POST["sec_eingabe"])."
				Session Captcha: ".strip_tags($_SESSION["captcha"])."
				Errors: ".strip_tags($_SESSION["iperror"])."
				IP: ".strip_tags($_SERVER['REMOTE_ADDR'])."
				Datum und Zeit: $datum "); 
		}
		
		//DE: Lschen der Session-var
		//ENG: Delete session var
		unset($_SESSION['captcha']);
		
		//DE: Umleitung zur homepage
		//ENG: Redirect to your homepage
		//**** ERSETZEN DURCH EIGENE DATEN **** REPLACE WITH YOUR DATA ****
        header("Location: http://www.contentcharge.de/"); 
	}
	else {
		//DE:  Zu viele Versuche mit derselben IP ?
		//ENG: Too many tries with identical IP ?
		if($_SESSION['iperror']>=5) print("DE: Zu viele Versuche. ENG: To many tries.");
		
		//DE:  IP-Error-Counter erhhen
		//ENG: Increase IP-Error-Counter
		$_SESSION['iperror'] += 1;
		
		//DE:  Userinfo zum erneuten Versuch
		//ENG: Inform the user about the wrong code
		print('DE: BITTE PR&Uuml;FEN SIE DIE EINGABE IM SICHERHEITSFELD, ENG: CHECK THE CONTENT OF THE CAPTCHA<br />');
		
		//DE:  Link zum Formular
		//ENG: Give a link back to your contactform
		//**** ERSETZEN DURCH EIGENE DATEN **** REPLACE WITH YOUR DATA ****
		print('<a href="http://www.contentcharge.de/kontakt.php">DE: Zur&uuml;ck zur Kontaktseite, ENG: Back to contactform</a>'); 
    }
}

//DE: Wenn das Script ein Bild generieren soll
//ENG: The script needs to generate the picture
elseif ($_GET['doit'] == "gen"){

	//DE: Feldwert wird erstellt
	//ENG: Generate the fieldvalue
	$text = rand(100000,999999);
		
	//DE: Feldwert wird in Session-Array gespeichert
	//ENG: Save the fieldvalue in session-array
	$_SESSION['captcha'] = $text;
				
    header('Content-type: image/png');
    $img = ImageCreateFromPNG('security_background.png');
    $color = ImageColorAllocate($img, 0, 0, 0);
    $ttf = 'pristina.ttf'; 
    $ttfsize = 28; 
    $angle = rand(0,5); 
    $text_x = rand(5,50);
    $text_y = 30;
    imagettftext($img, $ttfsize, $angle, $text_x, $text_y, $color, $ttf, $text);
    imagepng($img);
    imagedestroy($img);
}

?>
